<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css" integrity="sha384-B0vP5xmATw1+K9KRQjQERJvTumQW0nPEzvF6L/Z6nronJ3oUOFUFpCjEUQouq2+l" crossorigin="anonymous"/>
    <title>BootStrap-Flex</title>
</head>
<body>
    <!-- containter-fluid --- no margin / container --- with margin -->
    <div class="container-fluid text-center">
        <h1>Boostrap Flex</h1>
        <p>Use the d-flex class to create a flex container and transform direct children into flex items.</p>

        <h2>Centering Elements</h2>

        <!-- 
            d-flex - the flex value will change the element into block-level container. It will make all the elements become "flexible" that allows them to occupy space enough for the content of an element and at the same time will have the elements appear beside each other. 
        
            d-flex = with side margin / row = without side margin 
        -->

        <!-- 
            justify-content-center - it will horizontally center all child elements and ot will only be accessible if the display value is flex. 

            justify-content-around - centers elements horizontally while creating space between elements and the borders of its parent contentainer. Only works on d-flex.
        
            align-items-center - it will vertically center all the child elements. Only accessible if the display value is flex.

            flex-column - display elements on top of each other.

            flex-column-reverse - display elements in reverse order.

            d-md-flex - apply flex values to the display property on a medium display.
        -->

        <div style="height:500px" class="bg-dark p-3 d-flex justify-content-center align-items-center flex-column">
            <div class="h-25 p-3 bg-success col-2">Flex Item A</div>
            <div class="h-25 p-3 bg-warning col-2">Flex Item B</div>
            <div class="h-25 p-3 bg-danger col-2">Flex Item C</div>
        </div>

        <!-- flex-row - changes how the elements display horizontally. -->
    
        <h2>Flex Row</h2>
        <div class="bg-dark p-3 d-flex flex-row">
            <div class="p-3 bg-success">Flex Item A</div>
            <div class="p-3 bg-warning">Flex Item B</div>
            <div class="p-3 bg-danger">Flex Item C</div>
        </div>

        <h2>Flex Row Reverse</h2>
        <div class="bg-dark p-3 d-flex flex-row-reverse">
            <div class="p-3 bg-success">Flex Item A</div>
            <div class="p-3 bg-warning">Flex Item B</div>
            <div class="p-3 bg-danger">Flex Item C</div>
        </div>

        <h2>Creating Space Between Elements</h2>
        <div class="bg-dark p-3 d-md-flex justify-content-around">
            <div class="p-3 bg-success">Flex Item A</div>
            <div class="p-3 bg-warning">Flex Item B</div>
            <div class="p-3 bg-danger">Flex Item C</div>
        </div>

        <!-- mr-auto - will occupy the remaining width of its parent container pushing all the other elements inline. -->

        <h2>Flexbox with Margin</h2>
        <div class="bg-dark p-3 d-flex">
            <div class="p-3 bg-success mr-auto">Flex Item A</div>
            <div class="p-3 bg-warning">Flex Item B</div>
            <div class="p-3 bg-danger">Flex Item C</div>
            <div class="p-3 bg-primary">Flex Item D</div>
        </div>

        <!-- d-flex - only works on child elements. grandchild elements are ignored so a new nested d-flex is needed. -->

        <h2>Nested Flex Element</h2>
        <div class="bg-dark p-3 d-md-flex">
            <div class="p-3 bg-success mr-auto">Flex Item A</div>
            <div class="d-flex justify-content-between w-50">
                <div class="p-3 bg-warning">Flex Item B</div>
                <div class="p-3 bg-danger">Flex Item C</div>
                <div class="p-3 bg-primary">Flex Item D</div>
            </div>
            
        </div>


    </div>






    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>
</body>
</html>